<ngx-loading [show]="loading" />

<div
  [ngClass]="[jds.borderBottom(1)]"
  [style.backgroundColor]="'#ffffff'"
>
  <div [ngClass]="jds.container">
    <div [ngClass]="[jds.pt(12), jds.mb(12)]">
      <app-breadcrumb [breadcrumb]="breadcrumb" />
    </div>
  </div>
</div>

<div [ngClass]="['my-visualization-edit', jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <app-header-form
      [type]="'update'"
      [data]="'Visualisasi'"
    />

    <form
      class="form"
      [formGroup]="myForm"
      (ngSubmit)="onSubmit()"
      (keydown.enter)="$event.stopPropagation()"
    >
      <jds-bi-accordion
        #acc="jdsBiAccordion"
        [destroyOnHide]="false"
        [closeOthers]="true"
        [activeIds]="'accordion-visualization-edit'"
        [colorScheme]="colorScheme"
        [ngClass]="['accordion-visualization-edit']"
      >
        <jds-bi-panel id="accordion-visualization-edit">
          <ng-template jdsBiPanelTitle>
            <div [ngClass]="[jds.fs(18), jds.p(20)]">Informasi Visualisasi</div>
          </ng-template>
          <ng-template jdsBiPanelContent>
            <div [ngClass]="[jds.p(20)]">
              <ng-container *ngIf="loadingVisualization">
                <ng-container *ngFor="let number of [0, 1]">
                  <ngx-skeleton-loader
                    [theme]="{
                      width: '40%',
                      'border-radius': '0',
                      height: '20px',
                      'margin-bottom': '10px'
                    }"
                  />
                  <ngx-skeleton-loader
                    [theme]="{
                      width: '100%',
                      'border-radius': '0',
                      height: '43px',
                      'margin-bottom': '10px'
                    }"
                  />
                </ng-container>
              </ng-container>

              <ng-container *ngIf="!loadingVisualization">
                <!-- Judul -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Judul <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <input
                    [colorScheme]="colorScheme"
                    jdsBiInput
                    type="text"
                    placeholder="Contoh : Indeks Keamanan Informasi"
                    formControlName="name"
                  />
                  <ng-container
                    *ngIf="
                      f.name?.invalid && (f.name?.dirty || f.name?.touched)
                    "
                  >
                    <div
                      *ngIf="f.name?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                    <div
                      *ngIf="f.name?.errors.maxlength"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Panjang maksimal 255 karakter
                    </div>
                  </ng-container>
                </div>

                <!-- Deskripsi -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Deskripsi <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <textarea
                    [colorScheme]="colorScheme"
                    jdsBiInput
                    placeholder="Contoh : Dataset ini berisi data Indeks Keamanan Informasi di Provinsi Jawa Barat periode tahun 2019"
                    rows="5"
                    formControlName="description"
                  ></textarea>
                  <ng-container
                    *ngIf="
                      f.description?.invalid &&
                      (f.description?.dirty || f.description?.touched)
                    "
                  >
                    <div
                      *ngIf="f.description?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                    <div
                      *ngIf="f.description?.errors.maxlength"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Panjang maksimal 255 karakter
                    </div>
                  </ng-container>
                </div>

                <!-- Thumbnail -->
                <div [ngClass]="jds.mb(16)">
                  <div
                    [ngClass]="jds.d('flex')"
                    [style.gap.px]="16"
                  >
                    <img
                      [src]="thumbPath === null ? thumbNull : thumbPath"
                      [style.width.px]="150"
                      [style.height.px]="150"
                      [style.objectFit]="'cover'"
                      loading="lazy"
                      alt="Visualization Thumbnail"
                    />
                    <div
                      [ngClass]="[jds.me('auto')]"
                      [style.width.%]="100"
                    >
                      <div
                        *ngIf="loadingUpload"
                        [ngClass]="[jds.progress, jds.mb(4)]"
                      >
                        <div
                          [ngClass]="[
                            jds.progressBar,
                            jds.progressBarStriped,
                            jds.progressBarAnimated,
                            jds.bg('success')
                          ]"
                          [style.width.%]="progressUpload"
                          role="progressbar"
                          aria-label="Upload Gambar"
                        ></div>
                      </div>

                      <label [ngClass]="jds.formLabel">
                        Thumbnail <span [ngClass]="jds.text('danger')">*</span>
                      </label>

                      <input
                        [colorScheme]="colorScheme"
                        (change)="onUpload($event)"
                        jdsBiInput
                        type="file"
                        accept=".png,.jpg,.jpeg,.svg"
                      />

                      <input
                        hidden
                        formControlName="image"
                      />
                    </div>
                  </div>
                </div>

                <!-- Link Embed -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Link Embed <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <input
                    [colorScheme]="colorScheme"
                    jdsBiInput
                    type="text"
                    placeholder="Contoh : https://public.tableau.com/views/VISUALISASI_Awal27092019/LokasidanJumlahTenagaKerjaPotensiObjekDaya..."
                    formControlName="url"
                  />
                  <ng-container
                    *ngIf="f.url?.invalid && (f.url?.dirty || f.url?.touched)"
                  >
                    <div
                      *ngIf="f.url?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                    <div
                      *ngIf="f.url?.errors.pattern"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      URL salah
                    </div>
                  </ng-container>
                </div>

                <!-- Topik -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Topik <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <ng-select
                    #topikSelect
                    [items]="topicData$ | async"
                    bindValue="id"
                    bindLabel="name"
                    placeholder="Topik"
                    formControlName="sektoral_id"
                  />
                  <ng-container
                    *ngIf="
                      f.sektoral_id?.invalid &&
                      (f.sektoral_id?.dirty || f.sektoral_id?.touched)
                    "
                  >
                    <div
                      *ngIf="f.sektoral_id?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                  </ng-container>
                </div>

                <!-- Organisasi -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Organisasi <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <ng-container *ngIf="satudataUser.role_name === 'walidata'">
                    <ng-select
                      #organisasiSelect
                      [items]="organizationData$ | async"
                      bindValue="kode_skpd"
                      bindLabel="nama_skpd"
                      placeholder="Organisasi"
                      formControlName="kode_skpd"
                    />
                  </ng-container>
                  <ng-container *ngIf="satudataUser.role_name === 'opd'">
                    <input
                      class="form-control"
                      type="hidden"
                      placeholder="Organisasi"
                      formControlName="kode_skpd"
                    />
                    <ng-select
                      #organisasiSelect
                      [items]="organizationData$ | async"
                      bindValue="kode_skpd"
                      bindLabel="nama_skpd"
                      placeholder="Organisasi"
                      formControlName="kode_skpd_opd"
                    />
                  </ng-container>
                  <ng-container
                    *ngIf="
                      f.kode_skpd?.invalid &&
                      (f.kode_skpd?.dirty || f.kode_skpd?.touched)
                    "
                  >
                    <div
                      *ngIf="f.kode_skpd?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                  </ng-container>
                </div>

                <!-- Klasifikasi -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Klasifikasi <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <ng-select
                    #klasifikasiSelect
                    [items]="classificationDatasetData$ | async"
                    (ngModelChange)="onSelectedClassificationDataset($event)"
                    bindValue="id"
                    bindLabel="name"
                    placeholder="Klasifikasi"
                    formControlName="dataset_class_id"
                  />
                  <ng-container
                    *ngIf="
                      f.dataset_class_id?.invalid &&
                      (f.dataset_class_id?.dirty || f.dataset_class_id?.touched)
                    "
                  >
                    <div
                      *ngIf="f.dataset_class_id?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                  </ng-container>
                </div>

                <!-- Hak Akses Data Dikecualikan -->
                <div
                  *ngIf="isShowAccess"
                  [ngClass]="jds.mb(16)"
                >
                  <label [ngClass]="jds.formLabel">
                    Hak Akses Data Dikecualikan
                    <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <ng-select
                    [items]="organizationInputData$ | async"
                    [multiple]="true"
                    [selectOnTab]="true"
                    [typeahead]="organizationInput$"
                    [loading]="organizationInputIsLoading"
                    [hideSelected]="true"
                    [minTermLength]="2"
                    [clearable]="false"
                    (add)="onAddAccessControl($event)"
                    (remove)="onRemoveAccessControl($event)"
                    placeholder="Contoh : Diskominfo"
                    bindLabel="satuan_kerja_nama"
                    typeToSearchText="Masukan Organisasi"
                    formControlName="access_control"
                  />
                </div>

                <!-- Jabatan -->
                <div
                  *ngIf="fdp.controls.length > 0"
                  [ngClass]="jds.mb(16)"
                >
                  <label [ngClass]="jds.formLabel">
                    Jabatan
                    <span [ngClass]="jds.text('danger')">*</span>
                  </label>

                  <jds-bi-accordion
                    #accOrg="jdsBiAccordion"
                    [destroyOnHide]="false"
                    [closeOthers]="false"
                    [colorScheme]="colorScheme"
                    [ngClass]="['accordion-organization']"
                  >
                    <ng-container
                      *ngFor="let dp of fdp.controls; let i = index"
                    >
                      <ng-container [formGroup]="dp">
                        <jds-bi-panel
                          [title]="
                            organizationStructureData[i].satuan_kerja_nama
                          "
                        >
                          <ng-template jdsBiPanelContent>
                            <ng-container
                              *ngFor="let l0 of dp.controls; let ill0 = index"
                            >
                              <app-form-access-control
                                [accessControlInput]="l0"
                                [organizationStructureDataInput]="
                                  organizationStructureData[i].data[ill0]
                                "
                              />
                            </ng-container>
                          </ng-template>
                        </jds-bi-panel>
                      </ng-container>
                    </ng-container>
                  </jds-bi-accordion>
                </div>

                <!-- Dataset Referensi -->
                <div [ngClass]="jds.mb(16)">
                  <label
                    [ngClass]="[
                      jds.formLabel,
                      jds.d('flex'),
                      jds.alignItems('center')
                    ]"
                  >
                    <span>Dataset Referensi</span>
                    <div
                      [ngClass]="jds.text('#337ab7')"
                      [popperPlacement]="'top'"
                      [popperTrigger]="'hover'"
                      popper="Dataset referensi adalah dataset yang digunakan sebagai sumber utama dalam pembuatan visualisasi"
                    >
                      <jds-bi-icon
                        [size]="14"
                        [ngClass]="jds.ms(8)"
                        name="circle-info"
                      />
                    </div>
                  </label>

                  <ng-container *ngFor="let vd of fvd.controls; let i = index">
                    <ng-container [formGroup]="vd">
                      <div [ngClass]="[jds.row, jds.mb(16)]">
                        <div [ngClass]="i === 0 ? jds.col(12) : jds.col(10)">
                          <ng-select
                            id="dataset-reference-{{ i }}"
                            [items]="dataDatasetOption$ | async"
                            [typeahead]="inputDataset$"
                            [minTermLength]="2"
                            [loading]="loadingDatasetOption"
                            bindLabel="name"
                            placeholder="Judul Dataset Referensi"
                            formControlName="dataset"
                            typeToSearchText="Inputkan Judul Dataset Referensi"
                            loadingText="Loading..."
                          />
                        </div>
                        <div
                          *ngIf="i > 0"
                          [ngClass]="jds.col(2)"
                        >
                          <div
                            [ngClass]="[
                              jds.d('flex'),
                              jds.justifyContent('center')
                            ]"
                          >
                            <button
                              [ngClass]="[
                                jds.button,
                                jds.buttonDanger,
                                jds.d('flex'),
                                jds.alignItems('center')
                              ]"
                              (click)="removeDataset(i)"
                              type="button"
                            >
                              <jds-bi-icon
                                [ngClass]="jds.me(8)"
                                name="trash"
                              />
                              <span>Hapus</span>
                            </button>
                          </div>
                        </div>
                      </div>
                    </ng-container>
                  </ng-container>
                </div>

                <div [ngClass]="jds.mb(16)">
                  <button
                    [ngClass]="[
                      jds.button,
                      jds.buttonLink,
                      jds.d('flex'),
                      jds.alignItems('center')
                    ]"
                    (click)="addDataset()"
                    type="button"
                  >
                    <jds-bi-icon
                      [ngClass]="jds.me(8)"
                      name="circle-plus"
                    />
                    <span>Tambah Dataset Referensi</span>
                  </button>
                </div>

                <!-- Divisualisasikan Oleh -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Divisualisasikan Oleh
                    <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <input
                    [colorScheme]="colorScheme"
                    jdsBiInput
                    type="text"
                    placeholder="Contoh : Jabar Digital Service"
                    formControlName="divisualisasikan_oleh"
                  />
                  <ng-container
                    *ngIf="
                      f.divisualisasikan_oleh?.invalid &&
                      (f.divisualisasikan_oleh?.dirty ||
                        f.divisualisasikan_oleh?.touched)
                    "
                  >
                    <div
                      *ngIf="f.divisualisasikan_oleh?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                    <div
                      *ngIf="f.divisualisasikan_oleh?.errors.maxlength"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Panjang maksimal 255 karakter
                    </div>
                  </ng-container>
                </div>

                <!-- Tahun Pembuatan Visualisasi -->
                <div [ngClass]="jds.mb(16)">
                  <label [ngClass]="jds.formLabel">
                    Tahun Pembuatan Visualisasi
                    <span [ngClass]="jds.text('danger')">*</span>
                  </label>
                  <input
                    [colorScheme]="colorScheme"
                    jdsBiInput
                    type="text"
                    placeholder="Contoh : 2020"
                    formControlName="tahun_pembuatan"
                  />
                  <ng-container
                    *ngIf="
                      f.tahun_pembuatan?.invalid &&
                      (f.tahun_pembuatan?.dirty || f.tahun_pembuatan?.touched)
                    "
                  >
                    <div
                      *ngIf="f.tahun_pembuatan?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                    <div
                      *ngIf="f.tahun_pembuatan?.errors.maxlength"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Panjang maksimal 255 karakter
                    </div>
                  </ng-container>
                </div>

                <hr />

                <!-- Tambah Kolom Baru -->
                <ng-container *ngFor="let vm of fvm.controls; let i = index">
                  <ng-container [formGroup]="vm">
                    <div [ngClass]="[jds.row, jds.mb(16)]">
                      <div [ngClass]="jds.col(5)">
                        <input
                          [colorScheme]="colorScheme"
                          jdsBiInput
                          type="text"
                          placeholder="Kolom"
                          formControlName="key"
                        />

                        <ng-container
                          *ngIf="
                            vm['controls'].key?.invalid &&
                            (vm['controls'].key?.dirty ||
                              vm['controls'].key?.touched)
                          "
                        >
                          <div
                            *ngIf="vm['controls'].key?.errors.maxlength"
                            [ngClass]="[jds.formText, jds.text('danger')]"
                          >
                            Panjang maksimal 255 karakter.
                          </div>
                        </ng-container>
                      </div>
                      <div [ngClass]="jds.col(5)">
                        <input
                          [colorScheme]="colorScheme"
                          jdsBiInput
                          type="text"
                          placeholder="Value"
                          formControlName="value"
                        />
                        <ng-container
                          *ngIf="
                            vm['controls'].value?.invalid &&
                            (vm['controls'].value?.dirty ||
                              vm['controls'].value?.touched)
                          "
                        >
                          <div
                            *ngIf="vm['controls'].value?.errors.maxlength"
                            [ngClass]="[jds.formText, jds.text('danger')]"
                          >
                            Panjang maksimal 255 karakter.
                          </div>
                        </ng-container>
                      </div>
                      <div [ngClass]="jds.col(2)">
                        <div
                          [ngClass]="[
                            jds.d('flex'),
                            jds.justifyContent('center')
                          ]"
                        >
                          <button
                            [ngClass]="[
                              jds.button,
                              jds.buttonDanger,
                              jds.d('flex'),
                              jds.alignItems('center')
                            ]"
                            (click)="removeMetadata(i)"
                            type="button"
                          >
                            <jds-bi-icon
                              [ngClass]="jds.me(8)"
                              name="trash"
                            />
                            <span>Hapus</span>
                          </button>
                        </div>
                      </div>
                    </div>
                  </ng-container>
                </ng-container>

                <div [ngClass]="jds.mb(16)">
                  <button
                    [ngClass]="[
                      jds.button,
                      jds.buttonLink,
                      jds.d('flex'),
                      jds.alignItems('center')
                    ]"
                    (click)="addMetadata()"
                    type="button"
                  >
                    <jds-bi-icon
                      [ngClass]="jds.me(8)"
                      name="circle-plus"
                    />
                    <span>Tambah Kolom Baru</span>
                  </button>
                </div>

                <div
                  [ngClass]="[
                    jds.d('flex'),
                    jds.justifyContent('end'),
                    jds.mt(32),
                    jds.mb(10)
                  ]"
                >
                  <button
                    [ngClass]="[jds.button, jds.buttonPrimary, jds.ms(16)]"
                    [disabled]="!myForm.valid"
                    type="submit"
                  >
                    Selanjutnya
                  </button>
                </div>
              </ng-container>
            </div>
          </ng-template>
        </jds-bi-panel>
      </jds-bi-accordion>
    </form>
  </div>
</div>
